Index: TWiki/Plugins.pm
===================================================================
--- TWiki/Plugins.pm	(revision 13172)
+++ TWiki/Plugins.pm	(working copy)
@@ -53,13 +53,13 @@
 =my $pref = $TWiki::Plugins::SESSION->writeWarning($message);=
 
 Methods in other modules such as Store must be accessed through
-the relevant TWiki sub-object, for example
+the relevant TWiki singleton object, for example
 
 =TWiki::Store::saveTopic(...)=
 
 should be replaced with
 
-=$TWiki::Plugins::SESSION->{store}->saveTopic(...)=
+=$TWiki::STORE->saveTopic(...)=
 
 Note that calling TWiki internal methods is very very bad practice,
 and should be avoided wherever practical.
@@ -113,7 +113,7 @@
 
 =pod
 
----++ ClassMethod new( $session )
+---++ ClassMethod new()
 
 Construct new singleton plugins collection object. The object is a
 container for a list of plugins and the handlers registered by the plugins.
@@ -122,13 +122,10 @@
 =cut
 
 sub new {
-    my ( $class, $session ) = @_;
+    my ( $class ) = @_;
 
     my $this = bless( {}, $class );
 
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
-    $this->{session} = $session;
-
     unless( $inited ) {
         TWiki::registerTagHandler( 'PLUGINDESCRIPTIONS',
                                    \&_handlePLUGINDESCRIPTIONS );
@@ -162,8 +159,7 @@
 
     my %lookup;
 
-    my $session = $this->{session};
-    my $query = $session->{cgiQuery};
+    my $query = $TWiki::SESSION->{cgiQuery};
 
     my @pluginList = ();
     my %already;
@@ -199,7 +195,7 @@
     foreach my $pn ( @pluginList ) {
         my $p;
         unless( $p = $lookup{$pn} ) {
-            $p = new TWiki::Plugin( $session, $pn,
+            $p = new TWiki::Plugin( $pn,
                                     $TWiki::cfg{Plugins}{$pn}{Module} )
         }
         push @{$this->{plugins}}, $p;
@@ -216,7 +212,7 @@
         }
         # Report initialisation errors
         if( $p->{errors} ) {
-            $this->{session}->writeWarning( join( "\n", @{$p->{errors}} ));
+            $TWiki::SESSION->writeWarning( join( "\n", @{$p->{errors}} ));
         }
         $lookup{$pn} = $p;
     }
@@ -237,7 +233,7 @@
     ASSERT($this->isa( 'TWiki::Plugins')) if DEBUG;
 
     # Set the session for this call stack
-    local $TWiki::Plugins::SESSION = $this->{session};
+    local $TWiki::Plugins::SESSION = $TWiki::SESSION;
 
     foreach my $plugin ( @{$this->{plugins}} ) {
         $plugin->registerSettings( $this );
@@ -255,12 +251,12 @@
 sub enable {
     my $this = shift;
     ASSERT($this->isa( 'TWiki::Plugins')) if DEBUG;
-    my $prefs = $this->{session}->{prefs};
+    my $prefs = $TWiki::PREFS;
     my $dissed = $prefs->getPreferencesValue('DISABLEDPLUGINS') || '';
     my %disabled = map { $_ => 1 } split(/,\s*/, $dissed);
 
     # Set the session for this call stack
-    local $TWiki::Plugins::SESSION = $this->{session};
+    local $TWiki::Plugins::SESSION = $TWiki::SESSION;
 
     foreach my $plugin ( @{$this->{plugins}} ) {
         if ($disabled{$plugin->{name}}) {
@@ -270,7 +266,7 @@
         $plugin->registerHandlers( $this );
         # Report initialisation errors
         if ( $plugin->{errors} ) {
-            $this->{session}->writeWarning( join( "\n", @{$plugin->{errors}} ));
+            $TWiki::SESSION->writeWarning( join( "\n", @{$plugin->{errors}} ));
         }
     }
 }
@@ -327,7 +323,7 @@
 
     foreach my $plugin ( @{$this->{registeredHandlers}{$handlerName}} ) {
         # Set the value of $SESSION for this call stack
-        local $SESSION = $this->{session};
+        local $SESSION = $TWiki::SESSION;
         # apply handler on the remaining list of args
         no strict 'refs';
         my $status = $plugin->invoke( $handlerName, @_ );
@@ -359,7 +355,7 @@
 # %FAILEDPLUGINS reports reasons why plugins failed to load
 # note this is invoked with the session as the first parameter
 sub _handleFAILEDPLUGINS {
-    my $this = shift->{plugins};
+    my $this = $TWiki::PLUGINS;
 
     my $text = CGI::start_table( { border => 1, class => 'twikiTable' } ).
       CGI::Tr(CGI::th('Plugin').CGI::th('Errors'));
@@ -405,7 +401,7 @@
 
 # note this is invoked with the session as the first parameter
 sub _handlePLUGINDESCRIPTIONS {
-    my $this = shift->{plugins};
+    my $this = $TWiki::PLUGINS;
     my $text = '';
     foreach my $plugin ( @{$this->{plugins}} ) {
         $text .= CGI::li( $plugin->getDescription() . ' ' );
@@ -416,7 +412,7 @@
 
 # note this is invoked with the session as the first parameter
 sub _handleACTIVATEDPLUGINS {
-    my $this = shift->{plugins};
+    my $this = $TWiki::PLUGINS;
     my $text = '';
     foreach my $plugin ( @{$this->{plugins}} ) {
         unless( $plugin->{disabled} ) {
Index: TWiki/Store/RcsLite.pm
===================================================================
--- TWiki/Store/RcsLite.pm	(revision 13172)
+++ TWiki/Store/RcsLite.pm	(working copy)
@@ -230,7 +230,7 @@
     }
     my $fh = new FileHandle();
     if( ! $fh->open( $rcsFile ) ) {
-        $this->{session}->writeWarning( 'Failed to open '.$rcsFile );
+        $TWiki::SESSION->writeWarning( 'Failed to open '.$rcsFile );
         $this->{state} = 'nocommav';
         return;
     }
@@ -331,7 +331,7 @@
 
     unless( $state eq 'parsed' ) {
         my $error = $this->{rcsFile}.' is corrupt; parsed up to '.$state;
-        $this->{session}->writeWarning( $error );
+        $TWiki::SESSION->writeWarning( $error );
         #ASSERT(0) if DEBUG;
         $headNum = 0;
         $state = 'nocommav'; # ignore the RCS file; graceful recovery
Index: TWiki/Store/RcsFile.pm
===================================================================
--- TWiki/Store/RcsFile.pm	(revision 13172)
+++ TWiki/Store/RcsFile.pm	(working copy)
@@ -47,7 +47,7 @@
 
 =pod
 
----++ ClassMethod new($session, $web, $topic, $attachment)
+---++ ClassMethod new($web, $topic, $attachment)
 
 Constructor. There is one object per stored file.
 
@@ -56,10 +56,8 @@
 =cut
 
 sub new {
-    my( $class, $session, $web, $topic, $attachment ) = @_;
-    #ASSERT($session->isa( 'TWiki')) if DEBUG;
+    my( $class, $web, $topic, $attachment ) = @_;
     my $this = bless( {}, $class );
-    $this->{session} = $session;
 
     utf8::downgrade( $web ) if( $web && $] >= 5.008 );
     $this->{web} = $web;
@@ -342,7 +340,7 @@
 
     no strict 'refs';
     return &{$this->{searchFn}}($searchString, $topics, $options,
-               $sDir, $this->{session}->{sandbox});
+               $sDir, $TWiki::SANDBOX);
     use strict 'refs';
 }
 
@@ -473,8 +471,7 @@
     my $oldTopic = $this->{topic};
 
     # Move data file
-    my $new = new TWiki::Store::RcsFile( $this->{session},
-                                         $newWeb, $newTopic, '' );
+    my $new = new TWiki::Store::RcsFile( $newWeb, $newTopic, '' );
     _moveFile( $this->{file}, $new->{file} );
 
     # Move history
@@ -505,8 +502,7 @@
     my $oldWeb = $this->{web};
     my $oldTopic = $this->{topic};
 
-    my $new = new TWiki::Store::RcsFile( $this->{session},
-                                         $newWeb, $newTopic, '' );
+    my $new = new TWiki::Store::RcsFile( $newWeb, $newTopic, '' );
 
     _copyFile( $this->{file}, $new->{file} );
     if( -e $this->{rcsFile} ) {
@@ -518,7 +514,7 @@
         for my $att ( grep { !/^\./ } readdir DIR ) {
             $att = TWiki::Sandbox::untaintUnchecked( $att );
             my $oldAtt = new TWiki::Store::RcsFile(
-                $this->{session}, $this->{web}, $this->{topic}, $att );
+                $this->{web}, $this->{topic}, $att );
             $oldAtt->copyAttachment( $newWeb, $newTopic );
         }
 
@@ -538,7 +534,7 @@
     my( $this, $newWeb, $newTopic, $newAttachment ) = @_;
 
     # FIXME might want to delete old directories if empty
-    my $new = TWiki::Store::RcsFile->new( $this->{session}, $newWeb,
+    my $new = new TWiki::Store::RcsFile( $newWeb,
                                           $newTopic, $newAttachment );
 
     _moveFile( $this->{file}, $new->{file} );
@@ -563,7 +559,7 @@
     my $oldTopic = $this->{topic};
     my $attachment = $this->{attachment};
 
-    my $new = TWiki::Store::RcsFile->new( $this->{session}, $newWeb,
+    my $new = TWiki::Store::RcsFile->new( $newWeb,
                                           $newTopic, $attachment );
 
     _copyFile( $this->{file}, $new->{file} );
@@ -602,7 +598,7 @@
 sub setLock {
     my( $this, $lock, $user ) = @_;
 
-    $user = $this->{session}->{user} unless $user;
+    $user = $TWiki::SESSION->{user} unless $user;
 
     my $filename = $this->_controlFileName('lock');
     if( $lock ) {
Index: TWiki/Store/Subversive.pm
===================================================================
--- TWiki/Store/Subversive.pm	(revision 13172)
+++ TWiki/Store/Subversive.pm	(working copy)
@@ -26,11 +26,8 @@
 use TWiki::Time;
 
 sub new {
-    my( $class, $session, $web, $topic, $attachment ) = @_;
-
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
+    my( $class, $web, $topic, $attachment ) = @_;
     my $this = bless( {}, $class );
-    $this->{session} = $session;
 
     $this->{web} = $web;
 
@@ -82,7 +79,7 @@
         }
         close(F);
 
-        my ($output, $exit) = $this->{session}->{sandbox}->sysCommand(
+        my ($output, $exit) = $TWiki::SANDBOX->sysCommand(
             'svn add %FILENAME|F%',
             FILENAME => $this->{file});
         if( $exit ) {
@@ -104,7 +101,7 @@
             $path .= '/';
         } elsif( $path ) {
             if(  ! -e "$path$dir" && -e "$path/.svn" ) {
-                my($output, $exit) = $this->{session}->{sandbox}->sysCommand(
+                my($output, $exit) = $TWiki::SANDBOX->sysCommand(
                     'svn mkdir %FILENAME|F%',
                     FILENAME => $path.$dir);
                 if( $exit ) {
@@ -294,7 +291,7 @@
     my $maxTopicsInSet = 512; # max number of topics for a grep call
     my @take = @$topics;
     my @set = splice( @take, 0, $maxTopicsInSet );
-    my $sandbox = $this->{session}->{sandbox};
+    my $sandbox = $TWiki::SANDBOX;
     while( @set ) {
         @set = map { "$sDir/$_.txt" } @set;
         my ($matches, $exit ) = $sandbox->sysCommand(
@@ -433,8 +430,7 @@
     my $oldTopic = $this->{topic};
 
     # Move data file
-    my $new = new TWiki::Store::Subversive( $this->{session},
-                                            $newWeb, $newTopic, '' );
+    my $new = new TWiki::Store::Subversive( $newWeb, $newTopic, '' );
     $this->_moveFile( $this->{file}, $new->{file} );
 
     # Move attachments
@@ -459,8 +455,7 @@
     my $oldWeb = $this->{web};
     my $oldTopic = $this->{topic};
 
-    my $new = new TWiki::Store::Subversive( $this->{session},
-                                         $newWeb, $newTopic, '' );
+    my $new = new TWiki::Store::Subversive( $newWeb, $newTopic, '' );
 
     $this->_copyFile( $this->{file}, $new->{file} );
 
@@ -469,7 +464,7 @@
         for my $att ( grep { !/^\./ } readdir DIR ) {
             $att = TWiki::Sandbox::untaintUnchecked( $att );
             my $oldAtt = new TWiki::Store::Subversive(
-                $this->{session}, $this->{web}, $this->{topic}, $att );
+                $this->{web}, $this->{topic}, $att );
             $oldAtt->copyAttachment( $newWeb, $newTopic );
         }
 
@@ -481,7 +476,7 @@
     my( $this, $newWeb, $newTopic, $newAttachment ) = @_;
 
     # FIXME might want to delete old directories if empty
-    my $new = TWiki::Store::Subversive->new( $this->{session}, $newWeb,
+    my $new = TWiki::Store::Subversive->new( $newWeb,
                                           $newTopic, $newAttachment );
 
     $this->_moveFile( $this->{file}, $new->{file} );
@@ -494,7 +489,7 @@
     my $oldTopic = $this->{topic};
     my $attachment = $this->{attachment};
 
-    my $new = TWiki::Store::Subversive->new( $this->{session}, $newWeb,
+    my $new = TWiki::Store::Subversive->new( $newWeb,
                                           $newTopic, $attachment );
 
     $this->_copyFile( $this->{file}, $new->{file} );
@@ -556,7 +551,7 @@
 
     $this->_mkPathTo( $to );
 
-    my($output, $exit) = $this->{session}->{sandbox}->sysCommand(
+    my($output, $exit) = $TWiki::SANDBOX->sysCommand(
         'svn cp %FROM|F% %TO|F%',
         FROM => $from, TO => $to);
     if( $exit ) {
@@ -569,7 +564,7 @@
     my( $this, $from, $to ) = @_;
 
     $this->_mkPathTo( $to );
-    my($output, $exit) = $this->{session}->{sandbox}->sysCommand(
+    my($output, $exit) = $TWiki::SANDBOX->sysCommand(
         'svn mv %FROM|F% %TO|F%',
         FROM => $from, TO => $to);
     if( $exit ) {
@@ -661,7 +656,7 @@
 sub _rmtree {
     my ($this, $root) = @_;
 
-    my ($output, $exit) = $this->{session}->{sandbox}->sysCommand(
+    my ($output, $exit) = $TWiki::SANDBOX->sysCommand(
         'svn rm %FILENAME|F%',
         FILENAME => $root);
     if( $exit ) {
@@ -705,7 +700,7 @@
 sub numRevisions {
     my $this = shift;
 
-    my($output, $exit) = $this->{session}->{sandbox}->sysCommand(
+    my($output, $exit) = $TWiki::SANDBOX->sysCommand(
         'svn info %FILE|F%',
         FILE => $this->{file} );
     if( $exit ) {
@@ -731,7 +726,7 @@
         return [];
     }
 
-    my($output, $exit) = $this->{session}->{sandbox}->sysCommand(
+    my($output, $exit) = $TWiki::SANDBOX->sysCommand(
         'svn diff -r%FT|U% --non-interactive %FILE|F%',
         FT => $ft,
         FILE => $this->{file} );
Index: TWiki/Store/RcsWrap.pm
===================================================================
--- TWiki/Store/RcsWrap.pm	(revision 13172)
+++ TWiki/Store/RcsWrap.pm	(working copy)
@@ -68,7 +68,7 @@
     return if -e $this->{rcsFile};
 
     my ( $rcsOutput, $exit ) =
-      $this->{session}->{sandbox}->sysCommand(
+      $TWiki::SANDBOX->sysCommand(
           $TWiki::cfg{RCS}{initBinaryCmd}, FILENAME => $this->{file} );
     if( $exit ) {
         throw Error::Simple( $TWiki::cfg{RCS}{initBinaryCmd}.
@@ -93,7 +93,7 @@
     return if -e $this->{rcsFile};
 
     my ( $rcsOutput, $exit ) =
-      $this->{session}->{sandbox}->sysCommand
+      $TWiki::SANDBOX->sysCommand
         ( $TWiki::cfg{RCS}{initTextCmd},
           FILENAME => $this->{file} );
     if( $exit ) {
@@ -153,7 +153,7 @@
 
     $this->_lock();
     my ($rcsOut, $exit) =
-      $this->{session}->{sandbox}->sysCommand(
+      $TWiki::SANDBOX->sysCommand(
           $TWiki::cfg{RCS}{ciDateCmd},
           DATE => $date,
           USERNAME => $user,
@@ -179,13 +179,13 @@
 
     # delete latest revision (unlock (may not be needed), delete revision)
     my ($rcsOut, $exit) =
-      $this->{session}->{sandbox}->sysCommand(
+      $TWiki::SANDBOX->sysCommand(
           $TWiki::cfg{RCS}{unlockCmd},
           FILENAME => $this->{file} );
 
     chmod( $TWiki::cfg{RCS}{filePermission}, $this->{file} );
 
-    ($rcsOut, $exit) = $this->{session}->{sandbox}->sysCommand(
+    ($rcsOut, $exit) = $TWiki::SANDBOX->sysCommand(
         $TWiki::cfg{RCS}{delRevCmd},
         REVISION => '1.'.$rev,
         FILENAME => $this->{file} );
@@ -198,7 +198,7 @@
 
     # Update the checkout
     $rev--;
-    ($rcsOut, $exit) = $this->{session}->{sandbox}->sysCommand(
+    ($rcsOut, $exit) = $TWiki::SANDBOX->sysCommand(
         $TWiki::cfg{RCS}{coCmd},
         REVISION => '1.'.$rev,
         FILENAME => $this->{file} );
@@ -233,13 +233,13 @@
         $tmpfile = $this->_mkTmpFilename();
         $tmpRevFile = $tmpfile.',v';
         copy( $this->{rcsFile}, $tmpRevFile );
-        my ($tmp, $status) = $this->{session}->{sandbox}->sysCommand(
+        my ($tmp, $status) = $TWiki::SANDBOX->sysCommand(
             $TWiki::cfg{RCS}{tmpBinaryCmd},
             FILENAME => $tmpRevFile );
         $file = $tmpfile;
         $coCmd =~ s/-p%REVISION/-r%REVISION/;
     }
-    my ($text, $status) = $this->{session}->{sandbox}->sysCommand(
+    my ($text, $status) = $TWiki::SANDBOX->sysCommand(
         $coCmd,
         REVISION => '1.'.$version,
         FILENAME => $file );
@@ -264,7 +264,7 @@
     }
 
     my ($rcsOutput, $exit) =
-      $this->{session}->{sandbox}->sysCommand
+      $TWiki::SANDBOX->sysCommand
         ( $TWiki::cfg{RCS}{histCmd},
           FILENAME => $this->{rcsFile} );
     if( $exit ) {
@@ -289,7 +289,7 @@
         if( !$version || $version > $this->numRevisions()) {
             $version = $this->numRevisions();
         }
-        my( $rcsOut, $exit ) = $this->{session}->{sandbox}->sysCommand
+        my( $rcsOut, $exit ) = $TWiki::SANDBOX->sysCommand
           ( $TWiki::cfg{RCS}{infoCmd},
             REVISION => '1.'.$version,
             FILENAME => $this->{rcsFile} );
@@ -323,7 +323,7 @@
         }
     } else {
         $contextLines = 3 unless defined($contextLines);
-        ( $tmp, $exit ) = $this->{session}->{sandbox}->sysCommand(
+        ( $tmp, $exit ) = $TWiki::SANDBOX->sysCommand(
             $TWiki::cfg{RCS}{diffCmd},
             REVISION1 => '1.'.$rev1,
             REVISION2 => '1.'.$rev2,
@@ -406,7 +406,7 @@
     if( defined( $date )) {
         $date = TWiki::Time::formatTime( $date , '$rcs', 'gmtime');
         $cmd = $TWiki::cfg{RCS}{ciDateCmd};
-        ($rcsOutput, $exit)= $this->{session}->{sandbox}->sysCommand(
+        ($rcsOutput, $exit)= $TWiki::SANDBOX->sysCommand(
             $cmd,
             USERNAME => $user,
             FILENAME => $this->{file},
@@ -414,7 +414,7 @@
             DATE => $date );
     } else {
         $cmd = $TWiki::cfg{RCS}{ciCmd};
-        ($rcsOutput, $exit)= $this->{session}->{sandbox}->sysCommand(
+        ($rcsOutput, $exit)= $TWiki::SANDBOX->sysCommand(
             $cmd,
             USERNAME => $user,
             FILENAME => $this->{file},
@@ -436,7 +436,7 @@
     return unless -e $this->{rcsFile};
 
     # Try and get a lock on the file
-    my ($rcsOutput, $exit) = $this->{session}->{sandbox}->sysCommand(
+    my ($rcsOutput, $exit) = $TWiki::SANDBOX->sysCommand(
         $TWiki::cfg{RCS}{lockCmd}, FILENAME => $this->{file} );
 
     if( $exit ) {
@@ -445,9 +445,9 @@
         # scenarios - see Item2102
         if ((time - (stat($this->{rcsFile}))[9]) > 3600) {
             warn 'Automatic recovery: breaking lock for ' . $this->{file} ;
-            $this->{session}->{sandbox}->sysCommand(
+            $TWiki::SANDBOX->sysCommand(
                 $TWiki::cfg{RCS}{breaklockCmd}, FILENAME => $this->{file} );
-        ($rcsOutput, $exit) = $this->{session}->{sandbox}->sysCommand(
+        ($rcsOutput, $exit) = $TWiki::SANDBOX->sysCommand(
                 $TWiki::cfg{RCS}{lockCmd}, FILENAME => $this->{file} );
         }
        if ( $exit ) {
@@ -468,7 +468,7 @@
         return undef;
     }
 	$date = TWiki::Time::formatTime( $date , '$rcs', 'gmtime');
-    my ($rcsOutput, $exit) = $this->{session}->{sandbox}->sysCommand(
+    my ($rcsOutput, $exit) = $TWiki::SANDBOX->sysCommand(
         $TWiki::cfg{RCS}{rlogDateCmd},
         DATE => $date,
         FILENAME => $this->{file} );
Index: TWiki/Meta.pm
===================================================================
--- TWiki/Meta.pm	(revision 13172)
+++ TWiki/Meta.pm	(working copy)
@@ -54,20 +54,18 @@
 
 =pod
 
----++ ClassMethod new($session, $web, $topic)
+---++ ClassMethod new($web, $topic)
 
 Construct a new, empty Meta collection.
 
 =cut
 
 sub new {
-    my ( $class, $session, $web, $topic ) = @_;
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
+    my ( $class, $web, $topic ) = @_;
     my $this = bless( {}, $class );
 
     # Note: internal fields must be prepended with _. All other
     # fields will be assumed to be meta-data.
-    $this->{_session} = $session;
 
     ASSERT($web) if DEBUG;
     ASSERT($topic) if DEBUG;
@@ -388,14 +386,14 @@
 sub getRevisionInfo {
     my( $this, $fromrev ) = @_;
     ASSERT($this->isa( 'TWiki::Meta')) if DEBUG;
-    my $store = $this->{_session}->{store};
+    my $store = $TWiki::STORE;
 
     my $topicinfo = $this->get( 'TOPICINFO' );
 
     my( $date, $author, $rev, $comment );
     if( $topicinfo ) {
         $date = $topicinfo->{date} ;
-        $author = $this->{_session}->{users}->findUser($topicinfo->{author});
+        $author = $TWiki::USERS->findUser($topicinfo->{author});
         $rev = $topicinfo->{version};
         $rev =~ s/^\$Rev(:\s*\d+)?\s*\$$/0/; # parse out SVN keywords in doc
         $rev =~ s/^\d+\.//;
@@ -439,7 +437,7 @@
                     my $merged = TWiki::Merge::merge2(
                         'A', $otherD->{value}, 'B', $thisD->{value},
                         '.*?\s+',
-                        $this->{_session},
+                        $TWiki::SESSION,
                         $formDef->getField( $thisD->{name} ) );
                     # SMELL: we don't merge attributes or title
                     $thisD->{value} = $merged;
